############################################################################
#
#  Program:         SuperLU_DIST
#
#  Module:          make.inc
#
#  Purpose:         Top-level Definitions
#
#  Creation date:   February 4, 1999   version alpha
#
#  Modified:	    September 1, 1999  version 1.0
#                   March 15, 2003     version 2.0
#
############################################################################
#
#  The machine (platform) identifier to append to the library names
#
PLAT		= _sp

#
#  The name of the libraries to be created/linked to
#
DSuperLUroot 	= $(HOME)/SuperLU_DIST_2.0
DSUPERLULIB   	= $(DSuperLUroot)/superlu$(PLAT).a
#
BLASDEF	     	= -DUSE_VENDOR_BLAS
BLASLIB      	= -lessl
#MPILIB		= -L/usr/lpp/ppe.poe/lib -lmpi
#PERFLIB     	= -L/vol1/VAMPIR/lib -lVT
LIBS	     	= $(DSUPERLULIB) $(BLASLIB) $(PERFLIB) $(MPILIB)

#
#  The archiver and the flag(s) to use when building archive (library)
#  If your system has no ranlib, set RANLIB = echo.
#
ARCH         	= ar
# 64-bit:
# ARCHFLAGS    	= -X64 cr
ARCHFLAGS    	= cr
RANLIB       	= ranlib

# 64-bit
# CC           	= mpcc_r
CC           	= mpcc
CFLAGS          = -D_SP -O3 -qarch=PWR3 -qalias=allptrs \
		  -DDEBUGlevel=0 -DPRNTlevel=0 #-qwarn64 -D_LONGINT
NOOPTS		= #-q64
FORTRAN         = mpxlf90
FFLAGS          = -WF,-Dsp -O3 -Q -qstrict -qfixed -qinit=f90ptr -qarch=pwr3\
		  #-qintsize=8
#		  -qfree -qsuffix=f=f90 -q64 #-qintsize=8
LOADER	        = mpxlf90_r
# 32-bit:
LOADOPTS	= -bmaxdata:0x70000000
# 64-bit:
# LOADOPTS	= -q64
#
#  C preprocessor defs for compilation (-DNoChange, -DAdd_, or -DUpCase)
#
CDEFS        = -DNoChange


